// AJOUTER
var take_snapshots = function (count, Vduplicate) {
    if (Vduplicate == undefined) Vduplicate = false;
    else $("#snapshots").append("<input type='checkbox' id='dupl' checked />").css("display:none;");


    var snapshot = camera.capture();
    $("#play").prop("disabled", false);


    if ($('#optionSon').prop('checked') && Vduplicate == false) {
        var audioElement = document.createElement('audio');

        audioElement.setAttribute('type', 'audio/ogg');
        audioElement.setAttribute('src', 'files/audio/shutter.ogg');
        audioElement.setAttribute('autoplay', 'autoplay');
        audioElement.play();
    }
    if (JpegCamera.canvas_supported()) {
        snapshot.get_canvas(add_snapshot);
    } else {
        // <canvas> is not supported in this browser. We'll use anonymous
        // graphic instead.
        var image = document.createElement("img");
        image.src = "no_canvas_photo.jpg";
        setTimeout(function () {
            add_snapshot.call(snapshot, image)
        }, 1);
    }

    if (count > 1) {
        setTimeout(function () {
            take_snapshots(count - 1);
        }, 500);
    }
};
var add_snapshot = function (element) {
    if ($("#dupl").length > 0) {
        Vduplicate = true;
        $("#dupl").remove();
    } else Vduplicate = false;
    frameNumber = parseInt($("#frameNumber").text());
    frameNumber += 1;
    $("#frameNumber").text(frameNumber);

    if (frameNumber > 1) {
        $("#save").prop("disabled", false);
    }

    $(element).data("snapshot", this).addClass("item");
    $(element).attr('id', frameNumber);
    $(element).attr('draggable', true);
    $(element).attr('ondragover', "allowDrop(event)");
    $(element).attr('ondrop', "move(event)");
    $(element).attr('ondragstart', "drag(event)");




    var $container = $("#snapshots");
    $(element).insertBefore("#show_stream");

    numerotation(frameNumber);

    if ($("#show_stream").next().length > 0) {
        // Renuméroter si insert
        first = $("#show_stream").next().attr('id');
        i = parseInt(first) - 2;
        j = parseInt(first) - 1;
        nodes = document.getElementById("snapshots").childNodes;
        while (i < frameNumber + 1) {
            if (nodes[i].id != "show_stream") {

                nodes[i].id = j;
                numerotation(nodes[i].id);
                j++;
            }
            i++;
        }
        $("#snapshots").append($("#show_stream"));
    }
    var $camera = $("#camera");
    var camera_ratio = $camera.innerWidth() / $camera.innerHeight();

    var height = $container.height() - 5;
    element.style.height = "" + height + "px";
    element.style.width = "" + Math.round(camera_ratio * height) + "px";

    var scroll = $container[0].scrollWidth - $container.innerWidth();

    // Pas d'animation quand on duplique.
    if (Vduplicate == false) {
        $container.animate({
            scrollLeft: scroll
        }, 200);
    }


    show_stream();
};

// SELECTION
var select_snapshot = function (frame, multipleSelect) {

    frameNumber = parseInt($("#frameNumber").text());
    selectedFrame = $("#snapshots>.selected");
    if (selectedFrame.length > 0) selectedFrame = selectedFrame.attr('id');
    else selectedFrame = frameNumber + 1;
    if (frame <= frameNumber + 1 && frame > 0) {
        if (frame == frameNumber + 1) show_stream();
        else {
            $(".item").removeClass("selected");

            // Affichage du numéro de frame
            $("#currentFrame").text(frame);
            $("#currentFrame").prop("style", "");
            var snapshot = $("#" + frame).addClass("selected").data("snapshot");
            if (multipleSelect) {
                if (frame <= selectedFrame) {
                    i = frame;
                    maxtop = selectedFrame;
                } else {
                    i = selectedFrame;
                    maxtop = frame;
                }

                parseInt(i);
                parseInt(maxtop);

                while (i <= maxtop) {
                    $("#" + i).addClass("selected");
                    i++;
                }
            }

            snapshot.show();
            $('#camera > div > canvas').css("opacity", 1);
            $('#camera > div > canvas').css("mix-blend-mode", "normal");
            $("#camera > div > canvas").css("width", $("#camera").width());
            $("#camera > div > canvas").css("height", $("#camera").height());
        }
    }
};

// SUPPRESSION D'IMAGE
var discard_snapshot = function () {
    // récup données
    firstSelectedFrame = parseInt($('.selected:first').attr('id'));

    if (firstSelectedFrame) {
        lastSelectedFrame = parseInt($('.selected:last').attr('id'));

        selectedFrames = lastSelectedFrame - firstSelectedFrame + 1;

        frameNumber = parseInt($("#frameNumber").text());

        if (frameNumber <= selectedFrames) {
            $("#save").prop("disabled", true);
            $("#play").prop("disabled", true);
        }

        if (frameNumber == selectedFrames) {
            $("#currentFrame").text("DIRECT");
            $("#currentFrame").prop("style", "color: #E25353;");
        }


        // On diminue le total d'image.
        newFrameNumber = frameNumber - selectedFrames;
        $("#frameNumber").text(newFrameNumber);

        // On enlève la classe selected
        var element = $(".item.selected").removeClass("item selected");


        // On renumérote la suite
        for (i = firstSelectedFrame; i < frameNumber; i++) {
            nextFrame = i + selectedFrames;
            numerotation(nextFrame, i);
            $("#" + nextFrame).attr('id', i);

        }



        var next = element.nextAll(".item").first();

        if (!next.size()) {
            next = element.prevAll(".item").first();
        }

        if (next.size()) {
            next.addClass("selected");
            next.data("snapshot").show();
        }

        element.data("snapshot").discard();

        element.hide("slow", function () {
            $(this).remove()
        });

        if ($("#optionSynthese").prop('checked')) {
            u = new SpeechSynthesisUtterance();
            if ($("#lang").val() == 'fr') {
                u.lang = 'fr-FR';
                u.text = 'Image supprimée';
            } else {
                u.lang = 'en-EN';
                u.text = 'Frame deleted';
            }
            speechSynthesis.speak(u);
        }

        setDisplaySize();
    }



};

// AFFICHAGE DU STREAM
var show_stream = function () {

    $(".item").removeClass("selected");

    camera.show_stream();

    difference = true;
    if ($("#difference").hasClass("disabled")) difference = false;
    $("#currentFrame").text(window.textVariables.live);

    $("#currentFrame").prop("style", "color: #E25353;");

    // Onion blending : on affiche la dernière image par dessus en transparent
    frameNumber = parseInt($("#frameNumber").text());

    blend = $("#onionBlending>span").css('left');
    blend = parseInt(blend.substring(0, blend.length - 2)) / 120;

    var snapshot = $("#" + frameNumber).data("snapshot");
    snapshot.show();
    if (difference) {
        $('#camera > div > canvas').css("mix-blend-mode", "difference");
        blend = 1;
    }
    $('#camera > div > canvas').css("opacity", blend);

    $("#camera > div > canvas").css("width", $("#camera").width());
    $("#camera > div > canvas").css("height", $("#camera").height());
};

// LECTURE
var play = function () {
    frameNumber = parseInt($("#frameNumber").text());
    framerate = parseInt($("#framerate").val());
    $('#play').prop("style", "display:none;");
    $('#pause').prop("style", "display:inline-block;");

    var loop = true;
    var shortplay = true;
    pause = false;

    if ($("#loop").hasClass("disabled")) loop = false;
    if ($("#shortPlay").hasClass("disabled")) shortplay = false;

    var startFrame = 1;
    var shortNumber = frameNumber - 1;

    if (shortplay) shortNumber = $("#shortplayValue").val();

    if (shortNumber >= frameNumber) shortNumber = frameNumber - 1

    startFrame = frameNumber - shortNumber;


    function showFrame(frame, frameNumber) {
        setTimeout(function () {

            if (frame <= frameNumber) {
                var snapshot = $("#" + frame).data("snapshot");
                snapshot.show();
                $("#" + frame).addClass("selected");
                if (frame > 0) $("#" + (frame - 1)).removeClass("selected");
                $('#camera > div > canvas').css("opacity", 1);
                $("#camera > div > canvas").css("width", $("#camera").width());
                $("#camera > div > canvas").css("height", $("#camera").height());
            }

            if (frame < frameNumber + 1 && pause == false) showFrame(frame + 1, frameNumber); //Si on est pas encore à la dernière frame, on relance la fonction en incrémentant.
            else { // dernière frame, on revient sur le stream et on relance si loop
                show_stream();
                if (pause == false && loop == true) {
                    frame = startFrame;
                    showFrame(frame, frameNumber);
                } else {
                    $('#pause').prop("style", "display:none;");
                    $('#play').prop("style", "display:inline-block;");
                }
            }
            frame++;

        }, 1000 / framerate)
    }
    showFrame(startFrame, frameNumber);
};

//SAUVEGARDE
var save = function (type) {
    frameNumber = parseInt($("#frameNumber").text());
    framerate = parseInt($("#framerate").val());
    initialWidth = $("#1").data('snapshot')._canvas.width;
    initialHeight = $("#1").data('snapshot')._canvas.height;
    ratio = parseInt($("#letterboxValue").val());

    saveName = $("#saveName").val().split(' ').join('_');
    saveName = saveName.replace(/[^\w\s]/gi, '');
    if (saveName == "") saveName = "animation";

    isOffline = false;
    if (typeof require === "function") {
        isOffline = true;
        var os = require('os');
        platform = os.platform();
        saveFolder = $("#saveFolder");
        if (platform == "win32") {
            saveFolder = $("#saveFolder").val() + '\\';
        } else {
            saveFolder = $("#saveFolder").val() + '/';
        }

        var fs = require('fs-extra');

        // On s'assure que le dossier existe bien (créé sinon).
        fs.ensureDir('./encode/', function (err) {
            console.log(err)
        });

        fs.emptyDir('./encode/', function (err) {
            if (err) console.log(err)
        });
    }
    if (saveFolder != "/" || isOffline == false) {

        $("#submitExport").prop("disabled", true);
        progressValue = 0;
        $("#downloadLinks").css("display", "none");
        $("#progressPop").css("display", "inline-block");
        $("#progressLabel").html(window.textVariables.preparation);
        $("#progressProgress").css("width", progressValue + "%");
        $("#progressNumber").html(progressValue + "%");


        var frame = 1;

        if (type == "webm" || type == "h264" || type == "prores" || type == "avi") {
            saveFramerate = parseInt($("#saveFramerate").val());

            if (type == "h264" || type == "prores" || type == "avi") {
                ratioAction = parseInt($("input[type='radio'][name='aspectRatio']:checked").val());
            }
        }

        if (type == "webm") var video = new Whammy.Video(saveFramerate);
        else if (type == "images" && isOffline == false) {
            var zip = new JSZip();
            var photoZip = zip.folder(saveName);
        }

        boutonName = window.textVariables.boutonName;

        function showFrame(frame, frameNumber) {
            setTimeout(function () {
                // On récupère l'image dans le canvas  
                frameImage = $("#" + frame).data().snapshot._canvas;

                if (frameImage != undefined) // S'il y a bien une image.
                {
                    // On update le compteur
                    progressValue=Math.round((frame / frameNumber) * 100);
                    $("#progressProgress").css("width", progressValue + "%");
                    $("#progressNumber").html(progressValue + "%");

                    // On en fait une image base64 et on choisi le nom
                    image = frameImage.toDataURL("image/jpeg", 1);
                    image = image.substring(22);
                    frameName = frame;
                    if (frame < 10) frameName = '000' + frame;
                    else if (frame < 100) frameName = '00' + frame;
                    else if (frame < 1000) frameName = '0' + frame;
                    else frameName = frame;
                    
                    if (type == "images") frameName = saveName+"_"+frameName;
                    
                    // On ajoute l'image à la vidéo
                    if (type == "webm") video.add(frameImage);
                    else // Si on veut les images
                    {
                        // Le dossier est soit celui où non veut les images, ou le dossier temp /encode/ si on veut la vidéo encodée
                        if (type == "images") folder = saveFolder;
                        else {
                            folder = './encode/';
                        }
                        // Si on est sur la version en ligne, c'est le zip.
                        if (isOffline == false) photoZip.file(frameName + ".jpg", image, {
                            base64: true
                        });
                        else {
                            // Sinon, c'est chacune dans le dossier
                            var fs = require("fs");
                            
                            fs.writeFile(folder + frameName + '.jpg', image, 'base64', function (err) {
                                if (err) return console.log(err);
                            });
                        }
                    }
                }

                if (frame < frameNumber) showFrame(frame + 1, frameNumber); //Si on est pas encore à la dernière frame, on relance la fonction en incrémentant.
                frame++;
                if (frame == frameNumber + 1) { // Si c'est la dernière image, on lance l'encodage
                    if (type == "webm") {
                        video.compile(false, function (output) {
                            var url = URL.createObjectURL(output);
                            $("#progressPop").append("<a class='bouton' id='download'>" + boutonName + "</a>");
                            $("#download").attr("href", url);
                            $("#download").attr("download", saveName + ".webm");
                        });
                    } else if (type == "h264" || type == "prores" || type == "avi") {
                        // On gère le crop/letterbox
                        ffratio = '';
                        videoRatio = initialWidth / initialHeight;
                        var topleft = {
                            x: "0"
                            , y: "0"
                        };
                        if (ratio > videoRatio) {
                            desiredHeight = Math.round(initialWidth / ratio);
                            desiredWidth = initialWidth;
                            topleft['y'] = Math.round((initialHeight - desiredHeight));
                            topleft['x'] = 0;
                            cropHeight = Math.round((initialHeight - desiredHeight));
                            cropWidth = "0";

                        } else {
                            desiredWidth = Math.round(initialHeight / ratio);
                            desiredHeight = initialHeight;
                            topleft['x'] = Math.round((initialWidth - desiredWidth));
                            cropWidth = Math.round((initialWidth - desiredWidth));
                            cropHeight = "0";
                            topleft['y'] = 0;
                        }
                        if (ratioAction == 1) // Crop
                        {
                            ffratio += '-filter:v  "crop=in_w-2*' + cropWidth + ':in_h-2*' + cropHeight + '"';
                        } else if (ratioAction == 2) {
                            //                       ffratio+='-filter:v  "crop=in_w-2*'+cropWidth+':in_h-2*'+cropHeight+'"';
                        }


                        // On commence par setter les paramètres de la vidéo
                        if (type == "h264") {
                            extension = ".mp4";
                            ffcodec = 'libx264';
                            pix_fmt = 'yuv420p';
                        } else if (type == "prores") {
                            extension = ".mov";
                            ffcodec = 'prores_ks -profile:v 3 -qscale:v 11 -vendor ap10';
                            pix_fmt = 'yuv422p10le';
                        } else if (type == "avi") {
                            extension = ".avi";
                            ffcodec = 'mpeg4 -vtag xvid';
                            pix_fmt = 'yuv420p';
                        }
                        // Terminer l'intégration du prores

                        ffinput = 'encode/%04d.jpg';
                        ffoutput = saveFolder + saveName + extension;
                        $("#ledebug").append(ffoutput);
                        ffframerate = saveFramerate;

                        if (platform == "darwin") ffmpeg = "./ffmpeg-mac";
                        else if (platform == "win32") {
                            var is64Bit = os.arch() === 'x64' || process.env.hasOwnProperty('PROCESSOR_ARCHITEW6432');
                            var bit = is64Bit ? 64 : 32;
                            ffmpeg = "ffmpeg-win" + bit;
                        } else if (platform == "linux") {
                            var is64Bit = os.arch() === 'x64' || process.env.hasOwnProperty('PROCESSOR_ARCHITEW6432');
                            var bit = is64Bit ? 64 : 32;
                            ffmpeg = "./ffmpeg-linux" + bit;
                        }

                        // On lance l'encoding
                        $("#progressLabel").html(window.textVariables.render);
                        progressValue=0;
                        $("#progressProgress").css("width", progressValue + "%");
                        $("#progressNumber").html(progressValue + "%");
                        var exec = require('child_process').exec;
                        requete = ffmpeg + '  -r ' + ffframerate + ' -i ' + ffinput + ' -c:v ' + ffcodec + ' -r ' + ffframerate + ' -pix_fmt ' + pix_fmt + ' ' + ffratio + ' ' + ffoutput + ' -progress file.txt';
                        
                        exec(requete, function (error, stdout, stderr) {
                            // On met à jour régulièrement le progress
                            function getFile() {
                                
                                var file = "./file.txt";
                                $.get(file, function (txt) {
                                    frameEnc = 0;
                                    progress = 0;
                                    // On découpe le fichier ligne par ligne et on le lit à l'envers.
                                    var lines = txt.split("\n");
                                    for (var i = 0, len = lines.length; i <= len; i++) {
                                        if (lines[i] != "" && lines[i] != undefined) {
                                            value = lines[i].split("=");

                                            if (value[0] == 'frame') {
                                                frameEnc = value[1];
                                            }
                                            if (value[0] == 'progress') progress = value[1];
                                        }
                                    }
                                    console.log('final ' + frameEnc + " " + progress);
                                    percentage = Math.round((frameEnc*100)/frameNumber) ;
                                    
                                    $("#progressProgress").css("width", percentage + "%");
                                    $("#progressNumber").html(percentage + "%");
                                    
                                    if (progress != "end") {
                                        setTimeout(getFile, 200);
                                    }
                                    else{
                                        $("#progressLabel").html(window.textVariables.done);
                                    }
                                });
                            }
                            getFile();
                            
                            
                            
                            // On affiche les infos dans la console
                            console.log('stdout: ' + stdout);
                            console.log('stderr: ' + stderr);

                            if (error !== null) {
                                console.log('exec error: ' + error);
                            }
                            

                            // Une fois que c'est fait, on vide le directory
                            fs.emptyDir('./encode/', function (err) {
                                if (err) console.log(err)
                            });
                        });
                    } else {
                        if (isOffline == false) // Images Zip
                        {
                            zip.generateAsync({
                                    type: "blob"
                                })
                                .then(function (blob) {
                                    var url = URL.createObjectURL(blob);
                                    $("#progressPop").append("<a class='bouton' id='download'>" + boutonName + "</a>");
                                    $("#download").attr("href", url);
                                    $("#download").attr("download", saveName + ".zip");
                                });
                        }
                    }
                }
            }, 1000 / framerate)
        }

        showFrame(1, frameNumber);
    }
};

// COPIE D'IMAGE
var duplicate = function (value) {
    frame = parseInt($('.selected:first').attr('id'));
    if (frame) {
        if (isNaN(value)) {
            openPop("duplicatePop");
            $("#duplicateValue").change(function () {
                value = $("#duplicateValue").val();
                value++;
                framerate = $("#framerate").val();
                secondes = Math.floor(value / framerate);
                images = value % framerate;
                if (images < 10) images = "0" + images;
                if (secondes < 10) secondes = "0" + secondes;
                $("#duplicateTime").text(secondes + ":" + images);
            });

        } else {

            frameUp = frame + 1;
            for (i = 1; i <= value; i++) {
                // On commence par prendre une photo
                take_snapshots(1, true);

                window.setTimeout(function () {
                    // Puis on copie l'image dedans.
                    var sourceCanvas = $("#" + frame).data("snapshot")._canvas;
                    var destinationCanvas = $("#snapshots>canvas").last().data("snapshot")._canvas;
                    var destinationCanvas2 = $("#snapshots>canvas").last().get(0);

                    destCtx = destinationCanvas.getContext('2d');
                    destCtx2 = destinationCanvas2.getContext('2d');
                    destCtx.drawImage(sourceCanvas, 0, 0);
                    destCtx2.drawImage(sourceCanvas, 0, 0);

                    // On le déplace après l'image dupliquée
                    $($("#" + frame)).after($("#snapshots>canvas").last());


                    // Puis on renumérote.
                    frameNumber = ($("#snapshots canvas").length);
                    j = frame;
                    for (j = frame; j < frameNumber + 1; j++) {
                        $("#snapshots canvas:eq(" + (j - 1) + ")").prop("id", j);
                        numerotation(j);
                    }
                    i++;
                }, 1);

            }
        }
    }
}